"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var slate=require("@gitbook/slate"),Immutable=require("immutable"),Immutable__default=_interopDefault(Immutable),uid=_interopDefault(require("uid")),is=_interopDefault(require("is")),entities=require("entities"),Html=require("html"),detectNewLine=_interopDefault(require("detect-newline")),htmlparser2=require("htmlparser2"),htmlclean=_interopDefault(require("htmlclean")),isAbsoluteURL=_interopDefault(require("is-absolute-url")),splitLines$1=_interopDefault(require("split-lines")),escapeStringRegexp=_interopDefault(require("escape-string-regexp")),trimNewlines=_interopDefault(require("trim-newlines")),trimTrailingLines=_interopDefault(require("trim-trailing-lines")),indentString=_interopDefault(require("indent-string")),warning=_interopDefault(require("warning")),ltrim=_interopDefault(require("ltrim")),rtrim=_interopDefault(require("rtrim")),jsYaml=require("js-yaml"),fm=_interopDefault(require("front-matter"));const BLOCKS={TEXT:"unstyled",CODE:"code_block",CODE_LINE:"code_line",BLOCKQUOTE:"blockquote",PARAGRAPH:"paragraph",FOOTNOTE:"footnote",HTML:"html_block",HR:"hr",HEADING_1:"header_one",HEADING_2:"header_two",HEADING_3:"header_three",HEADING_4:"header_four",HEADING_5:"header_five",HEADING_6:"header_six",TABLE:"table",TABLE_ROW:"table_row",TABLE_CELL:"table_cell",OL_LIST:"ordered_list",UL_LIST:"unordered_list",LIST_ITEM:"list_item",COMMENT:"comment",MATH:"math_block",DEFAULT:"paragraph"},ALL_BLOCKS=Object.values(BLOCKS),CONTAINERS={document:[BLOCKS.PARAGRAPH,...ALL_BLOCKS],[BLOCKS.BLOCKQUOTE]:[BLOCKS.TEXT,...ALL_BLOCKS],[BLOCKS.TABLE]:[BLOCKS.TABLE_ROW],[BLOCKS.TABLE_ROW]:[BLOCKS.TABLE_CELL],[BLOCKS.TABLE_CELL]:[BLOCKS.PARAGRAPH,...ALL_BLOCKS],[BLOCKS.LIST_ITEM]:[BLOCKS.TEXT,...ALL_BLOCKS],[BLOCKS.OL_LIST]:[BLOCKS.LIST_ITEM],[BLOCKS.UL_LIST]:[BLOCKS.LIST_ITEM],[BLOCKS.CODE]:[BLOCKS.CODE_LINE]},INLINES={HTML:"html",LINK:"link",IMAGE:"image",FOOTNOTE_REF:"footnote-ref",MATH:"math",VARIABLE:"variable"},LEAFS={[BLOCKS.PARAGRAPH]:!0,[BLOCKS.TEXT]:!0,[BLOCKS.TABLE_CELL]:!0,[BLOCKS.CODE_LINE]:!0},MARKS={BOLD:"BOLD",ITALIC:"ITALIC",CODE:"CODE",STRIKETHROUGH:"STRIKETHROUGH"},TABLE_ALIGN={LEFT:"left",RIGHT:"right",CENTER:"center"},VOID={[BLOCKS.HR]:!0,[BLOCKS.HTML]:!0,[BLOCKS.COMMENT]:!0,[INLINES.IMAGE]:!0},DEFAULTS={transform:e=>e};class RuleFunction extends(Immutable.Record(DEFAULTS)){static exec(e,...t){return e instanceof RuleFunction?e.exec(...t):e(...t)}compose(e){let{transform:t}=this;return t=e(t),this.merge({transform:t})}then(e){return this.compose(t=>r=>{const i=t(r);if(void 0!==i)return e(i)})}tap(e){return this.compose(t=>r=>{const i=t(r);return e(i),i})}use(e){return this.then(t=>{let r;return e.some(e=>(r=RuleFunction.exec(e,t),Boolean(r))),r})}filter(e){return this.compose(t=>r=>{const i=t(r);if(i&&e(i))return i})}filterNot(e){return this.filter(t=>!RuleFunction.exec(e,t))}exec(e,t){return this.transform(e)}}class Deserializer extends RuleFunction{matchRegExp(e,t){let r,i=e;return i instanceof Array||(i=[i]),i=Immutable.List(i),this.filter(e=>i.some(t=>r=t.exec(e.text))).then(e=>t(e.skip(r[0].length),r))}}const DeserializerFactory=()=>new Deserializer;class Serializer extends RuleFunction{matchType(e){const t=normalizeMatcher(e);return this.filter(e=>{const r=e.peek(),{type:i}=r;return t(i)})}matchObject(e){const t=normalizeMatcher(e);return this.filter(e=>{const r=e.peek(),{object:i}=r;return t(i)})}matchMark(e){const t=normalizeMatcher(e);return this.matchObject("text").filter(e=>{return e.peek().getLeaves().some(e=>{return e.marks.some(e=>t(e.type))})})}transformLeaves(e){return this.matchObject("text").then(t=>{let r=t.peek().getLeaves();r=r.map(r=>e(t,r));const i=slate.Text.create({leaves:r});return t.shift().unshift(i)})}transformMarkedLeaf(e,t){const r=normalizeMatcher(e);return this.matchMark(r).transformLeaves((e,i)=>{let{text:a,marks:s}=i;const n=i.marks.find(({type:e})=>r(e));return n?(a=t(e,a,n),s=s.delete(n),i.merge({text:a,marks:s})):i})}transformText(e){const t=uid();return this.matchObject("text").filter(e=>{return!e.peek().isEmpty}).filterNot((new Serializer).matchMark(t)).transformLeaves((r,i)=>{const a=e(r,i);return a.merge({marks:a.marks.add(slate.Mark.create({type:t}))})})}}function normalizeMatcher(e){switch(typeof e){case"function":return e;case"string":return t=>t==e;default:if(Array.isArray(e))return t=>e.includes(t);throw new Error("Cannot normalize matcher")}}const SerializerFactory=()=>new Serializer,DEFAULTS$1={text:"",nodes:Immutable.List(),stack:Immutable.Stack(),marks:Immutable.Set(),object:String("document"),rulesSet:Immutable.Map(),depth:0,props:Immutable.Map()};class State extends(Immutable.Record(DEFAULTS$1)){static create(e={},t={}){return new State({rulesSet:Immutable.Map(e).map(Immutable.List),props:Immutable.Map(t)})}get rules(){const{object:e,rulesSet:t}=this;return t.get(e,Immutable.List())}use(e){return this.merge({object:e})}setProp(e,t){let{props:r}=this;return r=r.set(e,t),this.merge({props:r})}getProp(e,t){const{props:r}=this;return r.get(e,t)}write(e){let{text:t}=this;return t+=e,this.merge({text:t})}replaceText(e){return this.merge({text:e})}peek(){return this.nodes.first()}shift(){let{nodes:e}=this;return e=e.shift(),this.merge({nodes:e})}unshift(e){let{nodes:t}=this;return t=t.unshift(e),this.merge({nodes:t})}push(e){let{nodes:t}=this;return t=Immutable.List.isList(e)?t.concat(e):t.push(e),this.merge({nodes:t})}pushMark(e){let{marks:t}=this;return t=t.add(e),this.merge({marks:t})}genText(e=""){const{marks:t}=this;let r=slate.Text.create({text:e,marks:t});return"block"==this.object&&(r=slate.Block.create({type:BLOCKS.TEXT,nodes:[r]})),r}pushText(e){return this.push(this.genText(e))}down({nodes:e=Immutable.List(),text:t=""}={}){return this.merge({depth:this.depth+1,nodes:e,text:t,stack:this.stack.push({object:this.object,nodes:this.nodes,text:this.text})})}up(){const{nodes:e,text:t,object:r}=this.stack.peek();return this.merge({depth:this.depth-1,nodes:e,text:t,object:r,stack:this.stack.pop()})}skip(e){let{text:t}=this;return t=t.slice(e),this.merge({text:t})}lex(e={}){const t=this,{text:r}=t,{rest:i="",trim:a=!0,stopAt:s=((e,t)=>null)}=e;let n=t;const l=a?i.trim():i;if(l&&(n=n.pushText(l)),!r)return n;const o=n.applyRules("deserialize");if(o==n)throw new Error("Some rule is returning an identical state (no-op). Make sure your rules either return undefined to pass their turn, or return a different state.");if(!o)return t.skip(1).lex({...e,rest:i+r[0]});const c=s(o,t);return c||o.lex(e)}applyRules(e){const t=this,{rules:r}=t;let i;return r.filter(t=>t[e]).forEach(r=>!(i=RuleFunction.exec(r[e],t))),i}deserialize(e){return this.down({text:e}).lex().nodes}deserializeToDocument(e){const t=this.use("document").deserialize(e).get(0)||slate.Document.create();let{nodes:r}=t;return 0===r.size&&(r=r.push(slate.Block.create({type:BLOCKS.PARAGRAPH,nodes:[slate.Text.create()]}))),t.merge({nodes:r})}serialize(e){return this.down({nodes:Immutable.List(e)})._serialize().text}serializeDocument(e){return this.use("document").serialize([e])}serializeNode(e){return this.serialize([e])}_serialize(){let e=this;if(0==e.nodes.size)return e;if(!(e=e.applyRules("serialize")))throw new Error(`No rule match node ${this.peek().object}#${this.peek().type||""}`);if(e==this)throw new Error("A rule returns an identical state, returns undefined instead when passing.");return e._serialize()}}const ALIGNS="current_table_aligns",THEAD="next_row_is_header",COL="current_column",serializeTable={serialize:SerializerFactory().matchType(BLOCKS.TABLE).then(e=>{const t=e.peek(),r=t.data.get("aligns"),i=t.nodes,a=e.setProp(ALIGNS,r).setProp(COL,0).setProp(THEAD,!0).serialize(i.slice(0,1)),s=e.setProp(ALIGNS,r).setProp(COL,0).serialize(i.rest());return e.shift().write(["<table>","<thead>",`${a}</thead>`,"<tbody>",`${s}</tbody>`,"</table>","\n"].join("\n"))})},serializeRow={serialize:SerializerFactory().matchType(BLOCKS.TABLE_ROW).then(e=>{const t=e.peek(),r=e.setProp(COL,0).serialize(t.nodes);return e.shift().write(`<tr>\n${r}</tr>\n`)})},serializeCell={serialize:SerializerFactory().matchType(BLOCKS.TABLE_CELL).then(e=>{const t=e.peek(),r=e.getProp(THEAD),i=e.getProp(ALIGNS),a=e.getProp(COL),s=i[a],n=1===t.nodes.size&&t.nodes.first().type===BLOCKS.PARAGRAPH,l=e.serialize(n?t.nodes.first().nodes:t.nodes),o=r?"th":"td",c=s?` style="text-align:${s}"`:"";return e.shift().setProp(COL,a+1).write(`<${o}${c}>${l}</${o}>\n`)})};var table={table:serializeTable,row:serializeRow,cell:serializeCell};function escape(e){return entities.encodeXML(e)}function serializeTag(e,t={}){const{isSingleTag:r=!1,getAttrs:i=(e=>{})}=t;return t=>{const a=t.peek(),s=attrsToString(i(a));let n;if(r)n=`<${e}${s}/>`;else{const r=t.serialize(a.nodes);n=`<${e}${s}>${r}</${e}>`}return t.shift().write(n)}}function attrsToString(e){return new Immutable.Map(e).reduce((e,t,r)=>is.undef(t)||is.nil(t)?e:is.equal(t,"")?`${e} ${r}`:`${e} ${r}="${escape(t)}"`,"")}const serialize=SerializerFactory().matchType(BLOCKS.PARAGRAPH).then(serializeTag("p"));var paragraph={serialize:serialize};const serialize$1=SerializerFactory().matchType(BLOCKS.HR).then(serializeTag("hr",{isSingleTag:!0}));var hr={serialize:serialize$1};const serialize$2=SerializerFactory().matchType(BLOCKS.BLOCKQUOTE).then(serializeTag("blockquote"));var blockquote={serialize:serialize$2};const serialize$3=SerializerFactory().matchType(BLOCKS.CODE).then(e=>{const t=e.peek(),r=t.data.get("syntax"),i=t.nodes.map(e=>e.text).join("\n"),a=r?` class="lang-${r}"`:"";return e.shift().write(`<pre><code${a}>${escape(i)}</code></pre>\n`)});var code={serialize:serialize$3};const RULES={[BLOCKS.HEADING_1]:serializeTag("h1",{getAttrs:getAttrs}),[BLOCKS.HEADING_2]:serializeTag("h2",{getAttrs:getAttrs}),[BLOCKS.HEADING_3]:serializeTag("h3",{getAttrs:getAttrs}),[BLOCKS.HEADING_4]:serializeTag("h4",{getAttrs:getAttrs}),[BLOCKS.HEADING_5]:serializeTag("h5",{getAttrs:getAttrs}),[BLOCKS.HEADING_6]:serializeTag("h6",{getAttrs:getAttrs})},serialize$4=SerializerFactory().matchType(Object.keys(RULES)).then(e=>{const t=e.peek();return RULES[t.type](e)});function getAttrs(e){return{id:e.data.get("id")}}var heading={serialize:serialize$4};function containsTaskList(e){const{nodes:t}=e;return t.some(e=>e.data.has("checked"))}const serialize$5=SerializerFactory().matchType([BLOCKS.OL_LIST,BLOCKS.UL_LIST]).then(e=>{const t=e.peek(),r=t.type===BLOCKS.OL_LIST?"ol":"ul",i=containsTaskList(t),a=e.serialize(t.nodes);return e.shift().write(`<${r}${i?' class="contains-task-list"':""}>\n${a}</${r}>\n`)});var list={serialize:serialize$5};const serialize$6=SerializerFactory().matchType(BLOCKS.LIST_ITEM).then(e=>{const t=e.peek();let r=e.serialize(t.nodes),i="";const a=t.data.has("checked"),s=t.data.get("checked");return a&&(i=' class="task-list-item"',r=`<input type="checkbox" class="task-list-item-checkbox"${s?" checked":""} disabled /> ${r}`),e.shift().write(`<li${i}>${r}</li>\n`)});var listitem={serialize:serialize$6};const serialize$7=SerializerFactory().matchType(BLOCKS.TEXT).then(e=>{const t=e.peek();return e.shift().write(e.serialize(t.nodes))});var unstyled={serialize:serialize$7};const serialize$8=SerializerFactory().matchType(BLOCKS.FOOTNOTE).then(e=>{const t=e.peek(),r=e.serialize(t.nodes),i=t.data.get("id");return e.shift().write(`<blockquote id="fn_${i}">\n<sup>${i}</sup>. ${r}\n<a href="#reffn_${i}" title="Jump back to footnote [${i}] in the text."> &#8617;</a>\n</blockquote>\n`)});var footnote={serialize:serialize$8};const serialize$9=SerializerFactory().matchType(BLOCKS.HTML).then(e=>{const t=e.peek();return e.shift().write(`${t.data.get("html")}\n\n`)});var html={serialize:serialize$9},blocks=[paragraph,hr,blockquote,code,heading,list,listitem,unstyled,table.table,table.row,table.cell,footnote,html];const serialize$a=SerializerFactory().transformText((e,t)=>{const{text:r}=t;return t.merge({text:escape(r)})});var escape$1={serialize:serialize$a};const serialize$b=SerializerFactory().transformMarkedLeaf(MARKS.CODE,(e,t,r)=>`<code>${t}</code>`);var code$1={serialize:serialize$b};const serialize$c=SerializerFactory().transformMarkedLeaf(MARKS.BOLD,(e,t,r)=>`<b>${t}</b>`);var bold={serialize:serialize$c};const serialize$d=SerializerFactory().transformMarkedLeaf(MARKS.ITALIC,(e,t,r)=>`<em>${t}</em>`);var italic={serialize:serialize$d};const serialize$e=SerializerFactory().transformMarkedLeaf(MARKS.STRIKETHROUGH,(e,t,r)=>`<del>${t}</del>`);var strikethrough={serialize:serialize$e};const serialize$f=SerializerFactory().matchObject("text").then(e=>{const t=e.peek();let{text:r}=t;return r=r.replace(/(?:\r\n|\r|\n)/g,"<br />"),e.shift().write(r)});var text={serialize:serialize$f};const serialize$g=SerializerFactory().matchType(INLINES.IMAGE).then(serializeTag("img",{isSingleTag:!0,getAttrs:e=>({src:e.data.get("src"),alt:e.data.get("alt")})}));var image={serialize:serialize$g};const serialize$h=SerializerFactory().matchType(INLINES.LINK).then(serializeTag("a",{getAttrs:({data:e})=>({href:e.get("href")||"",title:e.get("title")||void 0})}));var link={serialize:serialize$h};const serialize$i=SerializerFactory().matchType(INLINES.FOOTNOTE_REF).then(e=>{const t=e.peek().data.get("id");return e.shift().write(`<sup><a href="#fn_${t}" id="reffn_${t}">${t}</a></sup>`)});var footnoteRef={serialize:serialize$i};const serialize$j=SerializerFactory().matchType(INLINES.HTML).then(e=>{const t=e.peek(),{html:r,openingTag:i,closingTag:a,innerHtml:s}=t.data.toObject();return r?e.shift().write(r):s?e.shift().write(i).write(s).write(a):e.shift().write(i).write(e.serialize(t.nodes)).write(a)});var html$1={serialize:serialize$j},inlines=[escape$1,code$1,bold,italic,strikethrough,text,image,link,footnoteRef,html$1];const INLINE_TAGS={a:INLINES.LINK,img:INLINES.IMAGE},BLOCK_TAGS={h1:BLOCKS.HEADING_1,h2:BLOCKS.HEADING_2,h3:BLOCKS.HEADING_3,h4:BLOCKS.HEADING_4,h5:BLOCKS.HEADING_5,h6:BLOCKS.HEADING_6,pre:BLOCKS.CODE,blockquote:BLOCKS.BLOCKQUOTE,p:BLOCKS.PARAGRAPH,hr:BLOCKS.HR,table:BLOCKS.TABLE,tr:BLOCKS.TABLE_ROW,th:BLOCKS.TABLE_CELL,td:BLOCKS.TABLE_CELL,ul:BLOCKS.UL_LIST,ol:BLOCKS.OL_LIST,li:BLOCKS.LIST_ITEM},MARK_TAGS={b:MARKS.BOLD,strong:MARKS.BOLD,del:MARKS.STRIKETHROUGH,em:MARKS.ITALIC,code:MARKS.CODE},MARK_CLASSNAME={"line-through":MARKS.STRIKETHROUGH},TAGS_TO_DATA={a:e=>({href:e.href,title:e.alt||""}),img:e=>({src:e.src,title:e.alt||""}),h1:resolveHeadingAttrs,h2:resolveHeadingAttrs,h3:resolveHeadingAttrs,h4:resolveHeadingAttrs,h5:resolveHeadingAttrs,h6:resolveHeadingAttrs};function resolveHeadingAttrs(e){return e.id?{id:e.id}:{}}function selectInlines(e){if("block"!==e.object)return Immutable.List([e]);const{nodes:t}=e;return t.reduce((e,t)=>e.concat(selectInlines(t)),Immutable.List())}function getMarksForClassName(e=""){const t=e.split(" "),r=[];return t.forEach(e=>{const t=MARK_CLASSNAME[e];if(!t)return;const i=slate.Mark.create({type:t});r.push(i)}),r}function acceptedBlocks(e){return CONTAINERS[e.type||e.object]}function isBlockContainer(e){return Boolean(acceptedBlocks(e))}function defaultBlockType(e){return acceptedBlocks(e)[0]}function canContain(e,t){if("inline"===t.object||"text"===t.object)return LEAFS[e.type];const r=acceptedBlocks(e);return r&&-1!==r.indexOf(t.type)}function sanitizeSpaces(e){return e.replace(/\xa0/g," ")}function getData(e,t){return(TAGS_TO_DATA[e]||(()=>{}))(t)}function isVoid(e){return Boolean(VOID[e])}function splitLines(e,t=detectNewLine(e)||"\n"){return Immutable.List(e.split(t))}function setNode(e,t){return e.pop().push(t)}function appendNode(e,t){const r=e.peek();let{nodes:i}=r;if(isBlockContainer(r)||"block"!=t.object)if(!isBlockContainer(r)||"block"===t.object&&canContain(r,t))i=i.push(t);else{const e=r.nodes.last();if(e&&canContain(e,t))i=i.pop().push(e.set("nodes",e.nodes.push(t)));else{const e=slate.Block.create({type:defaultBlockType(r),nodes:[t]});i=i.push(e)}}else i=i.concat(selectInlines(t));return setNode(e,r.merge({nodes:i}))}function pushNode(e,t){return e.push(t)}function popNode(e){return appendNode(e.pop(),e.peek())}function parse(e){const t=htmlclean(e),r=slate.Document.create({});let i=Immutable.Stack().push(r),a=Immutable.Set();const s=new htmlparser2.Parser({onopentag(e,t){if(BLOCK_TAGS[e]){const r=BLOCK_TAGS[e],a=slate.Block.create({data:getData(e,t),isVoid:isVoid(r),type:r});i=pushNode(i,a)}else if(INLINE_TAGS[e]){const r=INLINE_TAGS[e],a=slate.Inline.create({data:getData(e,t),isVoid:isVoid(r),type:r});i=pushNode(i,a)}else if(MARK_TAGS[e]){const r=slate.Mark.create({data:getData(e,t),type:MARK_TAGS[e]});a=a.add(r)}else if("br"==e){const e=slate.Text.create({text:"\n",marks:a});i=appendNode(i,e)}const r=getMarksForClassName(t.class);a=a.concat(r)},ontext(e){const t=sanitizeSpaces(e),r=slate.Text.create({text:t,marks:a});i=appendNode(i,r)},onclosetag(e){if(BLOCK_TAGS[e]||INLINE_TAGS[e]){const e=i.peek();if(e.type===BLOCKS.CODE){let t=splitLines(e.text);""===t.last().trim()&&(t=t.skipLast(1)),i=setNode(i,e.merge({nodes:t.map(e=>slate.Block.create({type:BLOCKS.CODE_LINE,nodes:[slate.Text.create(e)]}))}))}i=popNode(i)}else if(MARK_TAGS[e]){const t=MARK_TAGS[e];a=a.filter(e=>e.type!==t)}}},{decodeEntities:!0});if(s.write(t),s.end(),1!==i.size)throw new Error("Invalid HTML. A tag might not have been closed correctly.");return i.peek()}const serialize$k=SerializerFactory().matchObject("document").then(e=>{const t=e.peek(),{nodes:r}=t,i=e.use("block").serialize(r),a=Html.prettyPrint(i,{indent_size:2});return e.shift().write(a)}),deserialize=DeserializerFactory().then(e=>{const{text:t}=e,r=parse(t);return e.skip(t.length).push(r)});var document={serialize:serialize$k,deserialize:deserialize};const serialize$l=SerializerFactory().then(e=>e.shift());var ignoreNode={serialize:serialize$l};const ALL=[...blocks,...inlines,ignoreNode],HTMLParser={document:[document],block:ALL};function deserializeCodeLines(e){return splitLines$1(e).map(e=>slate.Block.create({type:BLOCKS.CODE_LINE,nodes:[slate.Text.create(e)]}))}function re(e){return new RegExp(escapeStringRegexp(e),"g")}function escapeWith(e,t){return e.reduce((e,t,r)=>e.replace(re(r),t),t)}function unescapeWith(e,t){return escapeWith(e.flip(),t)}const REPLACEMENTS_ESCAPE=Immutable.Map([["*","\\*"],["#","\\#"],["(","\\("],[")","\\)"],["[","\\["],["]","\\]"],["`","\\`"],["<","&lt;"],[">","&gt;"],["_","\\_"],["|","\\|"]]),REPLACEMENTS_UNESCAPE=REPLACEMENTS_ESCAPE.merge({" ":"\\ ","+":"\\+"}),URL_REPLACEMENTS_UNESCAPE=REPLACEMENTS_UNESCAPE.merge({" ":"%20"}),URL_REPLACEMENTS_ESCAPE=Immutable.Map([[" ","%20"],["(","%28"],[")","%29"]]);function escape$2(e,t){const r=escapeWith(REPLACEMENTS_ESCAPE,e);return!1===t?r:entities.encodeXML(r)}function unescape(e){return entities.decodeHTML(unescapeWith(REPLACEMENTS_UNESCAPE,e))}function escapeURL(e){return escapeWith(URL_REPLACEMENTS_ESCAPE,e)}function unescapeURL(e){let t;try{t=isAbsoluteURL(e)?e:decodeURI(e)}catch(r){if(!(r instanceof URIError))throw r;t=e}return unescapeWith(URL_REPLACEMENTS_UNESCAPE,t)}function replace(e,t=""){let{source:r}=e;return function e(i,a){if(!i)return new RegExp(r,t);let{source:s=a}=a;return s=s.replace(/(^|[^[])\^/g,"$1"),r=r.replace(i,s),e}}function resolveRef(e,t){const r=e.getProp("refs"),i=t.replace(/\s+/g," ").toLowerCase(),a=r.get(i);if(a)return Immutable.Map(a).filter(Boolean)}function wrapInline(e,t){return e.replace(/^\s*/,e=>`${e}${t}`).replace(/\s*$/,e=>`${t}${e}`)}const heading$1={normal:/^ *(#{1,6}) *([^\n]*?) *#* *(?:\n|$)/,line:/^([^\n]+)\n *(=|-){2,} *(?:\n|$)/,id:/({#)(.+)(})/g},inline={escape:/^\\([\\`*{}[\]()#$+\-.!_>|])/,autolink:/^<([^ >]+(@|:\/)[^ >]+)>/,url:/^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/,htmlComment:/^<!--[\s\S]*?-->/,htmlTagPair:/^<(\w+(?!:\/|[^\w\s@]*@)\b)+?((?:"[^"]*"|'[^']*'|[^'">])*?)>([\s\S]*?)<\/\1>/,htmlSelfClosingTag:/^<(\w+(?!:\/|[^\w\s@]*@)\b)(?:"[^"]*"|'[^']*'|[^'">/])*?\/?>/,link:/^!?\[(inside)\]\(href\)/,reflink:/^!?\[(inside)\]\s*\[([^\]]*)\]/,nolink:/^!?\[((?:\[[^\]]*\]|[^[\]])*)\]/,reffn:/^!?\[\^(inside)\]/,strong:/^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,em:/^\b_((?:__|[\s\S])+?)_\b|^\*((?:\*\*|[\s\S])+?)\*(?!\*)/,code:/^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,br:/^ {2,}\n(?!\s*$)/,del:/^~~(?=\S)([\s\S]*?\S)~~/,text:/^[\s\S]+?(?=[\\<![_*`$]| {2,}\n|$)/,math:/^\$\$([^$]+)\$\$/,variable:/^{{\s*(.*?)\s*(?=[#%}]})}}/},escapedButQuotesAndParen=/(?:\\\(|\\\)|\\"|\\'|[^()"'])/,escapedButQuotes=/(?:\\\(|\\\)|\\"|\\'|[^"'])/;inline._inside=/(?:\[[^\]]*\]|[^[\]]|\](?=[^[]*\]))*/,inline._href=/\s*<?(escapedHref*)>?(?:\s+['"](escapedTitle*?)['"])?\s*/,inline._href=replace(inline._href)("escapedHref",escapedButQuotesAndParen)("escapedTitle",escapedButQuotes)(),inline.link=replace(inline.link)("inside",inline._inside)("href",inline._href)(),inline.reflink=replace(inline.reflink)("inside",inline._inside)(),inline.reffn=replace(inline.reffn)("inside",inline._inside)(),inline.text=replace(inline.text)("]|","~]|")("|","|https?://|")("~]|",`~]|${inline.variable.source}|`)(),inline.escape=replace(inline.escape)("])","~|])")();const pipe=/\|/,table$1={cellSeparation:/^pipe/,nptable:/^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,normal:/^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/,cell:/ *pipe */,trailingPipe:/^ *| *pipe *$/g,trailingPipeAlign:/^ *|pipe *$/g,trailingPipeCell:/(?: *pipe *)?\n$/,edgePipesCell:/^ *pipe *| *pipe *$/g,alignRight:/^ *-+: *$/,alignCenter:/^ *:-+: *$/,alignLeft:/^ *:-+ *$/};table$1.cellSeparation=replace(table$1.cellSeparation)(/pipe/g,pipe)(),table$1.cell=replace(table$1.cell)(/pipe/g,pipe)(),table$1.trailingPipe=replace(table$1.trailingPipe,"g")(/pipe/g,pipe)(),table$1.trailingPipeAlign=replace(table$1.trailingPipeAlign,"g")(/pipe/g,pipe)(),table$1.trailingPipeCell=replace(table$1.trailingPipeCell,"g")(/pipe/g,pipe)(),table$1.edgePipesCell=replace(table$1.edgePipesCell,"g")(/pipe/g,pipe)(),table$1.cellInlineText=replace(inline.text)("]|","|]|")(),table$1.cellInlineEscape=inline.escape;const block={newline:/^\n+/,code:/^((?: {4}|\t)[^\n]+\n*)+/,hr:/^( *[-*_]){3,} *(?:\n|$)/,blockquote:/^( *>[^\n]+(\n(?!def|customBlock)[^\n]+)*\n*)+/,html:/^ *(?:comment *(?:\n|\s*$)|closed *(?:\n{2,}|\s*$)|closing *(?:\n{2,}|\s*$))/,def:/^ {0,3}\[([^\]]+)\]: *<?([^\s>]+)>?(?: +["(]([^\n]+)[")])? *(?:\n|$)/,footnote:/^\[\^([^\]]+)\]: ([^\n]+)/,paragraph:/^((?:(?:(?!notParagraphPart)[^\n])+\n?(?!notParagraphNewline))+)\n*/,text:/^[^\n]+/,fences:/^ *(`{3,}|~{3,})[ .]*(\S+)? *\n([\s\S]*?)\s*\1 *(?:\n+|$)/,yamlHeader:/^ *(?=```)/,math:/^ *(\${2,}) *(\n+[\s\S]+?)\s*\1 *(?:\n|$)/,list:{block:/^( *)(bullet) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1allbull )\n*|\s*$|(?=\ncustomBlock))/,item:/^( *)(bullet) [^\n]*(?:\n(?!\1allbull )[^\n]*)*/,bullet:/(?:[*+-]|\d+\.)/,bullet_ul:/(?:\d+\.)/,bullet_ol:/(?:[*+-])/,checkbox:/^\[([ x])\] +/,bulletAndSpaces:/^ *([*+-]|\d+\.) +/},customBlock:/^{% *(.*?) *(?=[#%}]})%}/,comment:/^{#\s*(.*?)\s*(?=[#%}]})#}/},notParagraphPart="customBlock",notParagraphNewline="hr|heading|lheading|blockquote|tag|def|math|comment|customBlock|table|tablenp|fences|ol",_tag="(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:\\/|[^\\w\\s@]*@)\\b";block.list.item=replace(block.list.item,"gm")(/allbull/g,block.list.bullet)(/bullet/g,block.list.bullet)(),block.blockquote=replace(block.blockquote)("def",block.def)("customBlock",block.customBlock)(),block.list.block=replace(block.list.block)(/allbull/g,block.list.bullet)("hr","\\n+(?=\\1?(?:[-*_] *){3,}(?:\\n+|$))")("def",`\\n+(?=${block.def.source})`)("footnote",block.footnote)("customBlock",block.customBlock)(),block.list.block_ul=replace(block.list.block)(/bullet/g,block.list.bullet_ul)(),block.list.block_ol=replace(block.list.block)(/bullet/g,block.list.bullet_ol)(),block.list.block=replace(block.list.block)(/bullet/g,block.list.bullet)(),block.html=replace(block.html)("comment",/<!--[\s\S]*?-->/)("closed",/<(tag)[^<]*?(?:>)[\s\S]+?<\/\1>/)("closing",/<tag(?:"[^"]*"|'[^']*'|[^'">/])*?\/?>/)(/tag/g,_tag)(),block.paragraph=replace(block.paragraph)("notParagraphPart","customBlock")("notParagraphNewline",notParagraphNewline)("hr",block.hr)("heading",heading$1.normal)("lheading",heading$1.line)("blockquote",block.blockquote)("tag",`<${_tag}`)("def",block.def)("math",block.math)("customBlock",block.customBlock)("comment",block.comment)("table",table$1.normal)("tablenp",table$1.nptable)("fences",block.fences.source.replace("\\1","\\2"))("ol",block.list.block_ol.source.replace("\\1","\\3"))();const serialize$m=SerializerFactory().matchType(BLOCKS.HR).then(e=>{const{depth:t,text:r}=e,i=2==t&&!r;return e.shift().write(`${i?"\n":""}---\n\n`)}),deserialize$1=DeserializerFactory().matchRegExp(block.hr,(e,t)=>{const r=slate.Block.create({type:BLOCKS.HR,isVoid:!0});return e.push(r)});var hr$1={serialize:serialize$m,deserialize:deserialize$1};const TYPES=[BLOCKS.HEADING_1,BLOCKS.HEADING_2,BLOCKS.HEADING_3,BLOCKS.HEADING_4,BLOCKS.HEADING_5,BLOCKS.HEADING_6],serialize$n=SerializerFactory().matchType(TYPES).then(e=>{const t=e.peek(),{type:r,data:i}=t,a=i.get("id"),s=TYPES.indexOf(r),n=Array(s+2).join("#");let l=e.use("inline").serialize(t.nodes);return a&&(l=`${l} <a id="${escape(a)}"></a>`),e.shift().write(`${n} ${l}\n\n`)}),deserializeNormal=DeserializerFactory().matchRegExp(heading$1.normal,(e,t)=>{return parseHeadingText(e,t[1].length,t[2])}),deserializeLine=DeserializerFactory().matchRegExp(heading$1.line,(e,t)=>{return parseHeadingText(e,"="===t[2]?1:2,t[1])}),deserialize$2=DeserializerFactory().use([deserializeNormal,deserializeLine]);function trimLeftNodesText(e){if(0===e.size)return e;const t=e.first();if("text"!==t.object)return e;const r=t.getLeaves(),i=r.first();return e.rest().unshift(t.setLeaves(r.rest().unshift(i.merge({text:i.text.trimLeft()}))))}function trimRightNodesText(e){if(0===e.size)return e;const t=e.last();if("text"!==t.object)return e;const r=t.getLeaves(),i=r.last();return e.butLast().push(t.setLeaves(r.butLast().push(i.merge({text:i.text.trimRight()}))))}function parseHeadingText(e,t,r){let i=r;heading$1.id.lastIndex=0;const a=heading$1.id.exec(i);let s;i=a?i.replace(a[0],"").trim():i.trim();const n=e.down({text:i}).use("inline").lex(),l=a&&a[2]||n.getProp("lastAnchorId")||null;l&&(s={id:l});const o=trimRightNodesText(trimLeftNodesText(n.nodes)),c=slate.Block.create({type:TYPES[t-1],nodes:o,data:s});return n.up().setProp("lastAnchorId",null).push(c)}var heading$2={serialize:serialize$n,deserialize:deserialize$2};const serialize$o=SerializerFactory().matchType(BLOCKS.PARAGRAPH).then(e=>{const t=e.peek(),r=e.use("inline").setProp("hardlineBreak",!0).serialize(t.nodes);return e.shift().write(`${r}\n\n`)}),deserialize$3=DeserializerFactory().matchRegExp(block.paragraph,(e,t)=>{const r=e.depth-1,i=e.getProp("blockquote")===r,a=e.getProp("looseList")===r;if(!(2===e.depth)&&!i&&!a)return;const s=collapseWhiteSpaces(t[1]),n=e.down({text:s}).use("inline").lex(),{nodes:l}=n,o=slate.Block.create({type:BLOCKS.PARAGRAPH,nodes:l});return n.up().push(o)});function collapseWhiteSpaces(e){return e.split("  \n").map(e=>e.trim().replace(/\s+/g," ")).join("  \n").trim()}var paragraph$1={serialize:serialize$o,deserialize:deserialize$3};const serialize$p=SerializerFactory().matchType(BLOCKS.CODE).then(e=>{const t=e.peek(),{nodes:r,data:i}=t,a=escape$2(i.get("syntax")||""),s=r.map(e=>e.text).join("\n");let n;return s.indexOf("`")>=0&&!a?(n=`${r.map(({text:e})=>e.trim()?`    ${e}`:"").join("\n")}\n\n`,e.shift().write(n)):(n=`\`\`\`${a||""}\n${s}\n\`\`\`\n\n`,e.shift().write(n))}),deserializeFences=DeserializerFactory().matchRegExp(block.fences,(e,t)=>{const r=trimNewlines(t[3]);let i;t[2]&&(i={syntax:unescape(t[2].trim())});const a=deserializeCodeLines(r),s=slate.Block.create({type:BLOCKS.CODE,nodes:a,data:i});return e.push(s)}),deserializeTabs=DeserializerFactory().matchRegExp(block.code,(e,t)=>{let r=t[0];const i=deserializeCodeLines(r=(r=r.replace(/^( {4}|\t)/gm,"")).replace(/\n+$/,"")),a=slate.Block.create({type:BLOCKS.CODE,nodes:i});return e.push(a)}),deserialize$4=DeserializerFactory().use([deserializeFences,deserializeTabs]);var codeBlock={serialize:serialize$p,deserialize:deserialize$4};const serialize$q=SerializerFactory().matchType(BLOCKS.BLOCKQUOTE).then(e=>{const t=e.peek(),r=e.use("block").serialize(t.nodes),i=splitLines$1(r.trim()).map(e=>e?`> ${e}`:">").join("\n");return e.shift().write(`${i}\n\n`)}),deserialize$5=DeserializerFactory().matchRegExp(block.blockquote,(e,t)=>{const r=t[0].replace(/^ *> ?/gm,"").trim(),i=e.use("block").setProp("blockquote",e.depth).deserialize(r),a=slate.Block.create({type:BLOCKS.BLOCKQUOTE,nodes:i});return e.push(a)});var blockquote$1={serialize:serialize$q,deserialize:deserialize$5};const serialize$r=SerializerFactory().matchType(BLOCKS.TEXT).then(e=>{const t=e.peek(),r=e.use("inline").serialize(t.nodes);return e.shift().write(`${r}\n`)}),deserialize$6=DeserializerFactory().matchRegExp(block.text,(e,t)=>{const r=t[0],i=e.use("inline").deserialize(r),a=slate.Block.create({type:BLOCKS.TEXT,nodes:i});return e.push(a)});var unstyled$1={serialize:serialize$r,deserialize:deserialize$6};const serialize$s=SerializerFactory().matchType(BLOCKS.FOOTNOTE).then(e=>{const t=e.peek(),r=e.use("inline").serialize(t.nodes),i=t.data.get("id");return e.shift().write(`[^${i}]: ${r}\n\n`)}),deserialize$7=DeserializerFactory().matchRegExp(block.footnote,(e,t)=>{const r=t[1],i=t[2],a=e.use("inline").deserialize(i),s=slate.Block.create({type:BLOCKS.FOOTNOTE,nodes:a,data:{id:r}});return e.push(s)});var footnote$1={serialize:serialize$s,deserialize:deserialize$7};const deserializeNoPipe=DeserializerFactory().matchRegExp(table$1.nptable,(e,t)=>{const r=t[0].split("\n").filter(Boolean),i=parseTable(e,r[0],r[1],r.slice(2));return e.push(i)}),deserializeNormal$1=DeserializerFactory().matchRegExp(table$1.normal,(e,t)=>{const r=t[0].split("\n").filter(Boolean),i=parseTable(e,r[0],r[1],r.slice(2));return e.push(i)}),serialize$t=SerializerFactory().matchType(BLOCKS.TABLE).then(e=>{const t=e.peek();if(mustSerializeAsHTML(t)){const r=State.create(HTMLParser).serializeDocument(slate.Document.create({nodes:[t]}));return e.shift().write(r)}const{data:r,nodes:i}=t,a=r.get("aligns"),s=i.get(0),n=i.slice(1),l=`${rowToText(e,s)}\n${alignsToText(a)}\n${n.map(t=>rowToText(e,t)).join("\n")}\n\n`;return e.shift().write(l)}),deserialize$8=DeserializerFactory().use([deserializeNoPipe,deserializeNormal$1]);function parseTable(e,t,r,i){const a=parseRow(e,t),s=i.map(t=>parseRow(e,t)),n=mapAligns(rowToCells(r));return slate.Block.create({type:BLOCKS.TABLE,data:{aligns:n},nodes:[a].concat(s)})}function parseRow(e,t){const r=rowToCells(t).map(t=>{const r=t.trim(),i=e.use("inline").deserialize(r),a=slate.Block.create({type:BLOCKS.PARAGRAPH,nodes:i});return slate.Block.create({type:BLOCKS.TABLE_CELL,nodes:[a]})});return slate.Block.create({type:BLOCKS.TABLE_ROW,nodes:r})}function rowToCells(e){const t=[],r=e.trim();let i=0;for(let e=0;e<r.length;e+=1){const a=0===e?0:e-1,s="|"===r[e],n="\\"!==r[a];s&&n&&(e>0&&e<r.length&&t.push(r.slice(i,e)),i=e+1)}return i<r.length&&t.push(r.slice(i)),t}function mapAligns(e){return e.map(e=>table$1.alignRight.test(e)?TABLE_ALIGN.RIGHT:table$1.alignCenter.test(e)?TABLE_ALIGN.CENTER:table$1.alignLeft.test(e)?TABLE_ALIGN.LEFT:null)}function rowToText(e,t){const{nodes:r}=t;return`| ${r.map(t=>cellToText(e,t)).join(" | ")} |`}function cellToText(e,t){const{nodes:r}=t;let i;return i=1===r.size&&r.first().type===BLOCKS.PARAGRAPH?r.first().nodes:r,e.use("inline").serialize(i)}function alignsToText(e){return`|${e.map(e=>"right"==e?" ---: |":"center"==e?" :---: |":"left"==e?" :--- |":" --- |").join("")}`}function mustSerializeAsHTML(e){return e.findDescendant(e=>e.type===BLOCKS.TABLE_CELL&&(e=>{const{nodes:t}=e,r=1===t.size&&t.first().type===BLOCKS.PARAGRAPH,i=t.every(e=>"block"!==e.object);return!r&&!i})(e))}var table$2={serialize:serialize$t,deserialize:deserialize$8};const serialize$u=SerializerFactory().matchType([BLOCKS.UL_LIST,BLOCKS.OL_LIST]).then(e=>{const t=e.peek(),{nodes:r}=t,i=r.map((r,i)=>serializeListItem(e,t,r,i)).join("");return e.shift().write(i)}),deserialize$9=DeserializerFactory().matchRegExp(block.list.block,(e,t)=>{const r=t[0],i=t[2].length>1?BLOCKS.OL_LIST:BLOCKS.UL_LIST;let a,s,n,l=!1,o=0;const c=[];let u,p,d;const m=[];block.list.item.lastIndex=0;do{null!==(a=block.list.item.exec(r))&&(u=r.slice(o,block.list.item.lastIndex),o=block.list.item.lastIndex,m.push([a,u]))}while(null!==a);for(let t=0;t<m.length;t+=1){a=m[t][0],u=m[t][1],n=void 0,d=(p=a[0]).length,p=p.replace(block.list.bulletAndSpaces,"");let r=block.list.checkbox.exec(p);r&&(r="x"===r[1],p=p.replace(block.list.checkbox,""),n={checked:r}),~p.indexOf("\n ")&&(d-=p.length,p=p.replace(new RegExp(`^ {1,${d}}`,"gm"),"")),s=l||/\n\n(?!\s*$)/.test(p),t!==m.length-1&&(l="\n"===p.charAt(p.length-1),s||(s=l));const i=slate.Block.create({type:BLOCKS.LIST_ITEM,data:n,nodes:(s?e.setProp("looseList",e.depth):e).use("block").deserialize(p)});c.push(i)}const h=slate.Block.create({type:i,nodes:c});return e.push(h)});function serializeListItem(e,t,r,i){const a=r.data.has("checked"),s=r.data.get("checked"),n=r.nodes.some(e=>e.type===BLOCKS.PARAGRAPH),l=t.nodes.size-1===i,o=t.type===BLOCKS.OL_LIST?`${i+1}.`:"*",c=o.length+1;let u=e.use("block").serialize(r.nodes);return u=`${trimTrailingLines(u)}\n`,u=indentString(u,c,{indent:" "}).slice(c),(n||l)&&(u+="\n"),a&&(u=`${s?"[x]":"[ ]"} ${u}`),`${o} ${u}`}var list$1={serialize:serialize$u,deserialize:deserialize$9};const reDef=/^ {0,3}\[(.+)]:[ \t]*\n?[ \t]*<?(\S+?)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*\n?[ \t]*(?:(\n*)["|'(](.+?)["|')][ \t]*)?(?:\n+|(?=~0))/gm;function cleanupText(e){return e.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n").replace(/^ +$/gm,"")}const deserialize$a=DeserializerFactory().then(e=>{const{depth:t,nodes:r}=e;let{text:i}=e;if(t>2||r.size>0||e.getProp("refs"))return;i=cleanupText(i);const a={};return i=i.replace(reDef,(e,t,r,i,s,n,l)=>(a[t.toLowerCase()]={href:r,title:l},"")),e.replaceText(i).setProp("refs",Immutable.Map(a))});var definition={deserialize:deserialize$a};const serialize$v=SerializerFactory().matchType(BLOCKS.MATH).then(e=>{const t=e.peek(),{data:r}=t,i=`$$\n${r.get("formula").trim()}\n$$\n\n`;return e.shift().write(i)}),deserialize$b=DeserializerFactory().matchRegExp(block.math,(e,t)=>{const r=t[2].trim();if(!1===e.getProp("math")||!r)return;const i=slate.Block.create({type:BLOCKS.MATH,isVoid:!0,data:{formula:r}});return e.push(i)});var math={serialize:serialize$v,deserialize:deserialize$b};const serialize$w=SerializerFactory().matchType(BLOCKS.COMMENT).then(e=>{const t=e.peek(),{data:r}=t,i=r.get("text");return e.shift().write(`{# ${i} #}`)}),deserialize$c=DeserializerFactory().matchRegExp(block.comment,(e,t)=>{if(!1===e.getProp("template"))return;const r=slate.Block.create({type:BLOCKS.COMMENT,isVoid:!0,data:{text:t[1].trim()}});return e.push(r)});var comment={serialize:serialize$w,deserialize:deserialize$c};const serialize$x=SerializerFactory().matchType(BLOCKS.HTML).then(e=>{const t=e.peek(),{data:r}=t;return e.shift().write(`${r.get("html").trim()}\n\n`)}),deserialize$d=DeserializerFactory().matchRegExp(block.html,(e,t)=>{const r=t[0].trim(),i=State.create(HTMLParser).deserializeToDocument(r),a=i.nodes.first();return 1===i.nodes.size&&a.type===BLOCKS.PARAGRAPH&&""===a.text?e:e.push(i.nodes)});var html$2={serialize:serialize$x,deserialize:deserialize$d};const singleQuoted=/'(?:[^'\\]|\\.)*'/,doubleQuoted=/"(?:[^"\\]|\\.)*"/,quoted=replace(/singleQuoted|doubleQuoted/)("singleQuoted",singleQuoted)("doubleQuoted",doubleQuoted)(),integer=/-?\d+/,number=/-?\d+\.?\d*|\.?\d+/,bool=/true|false/,identifier=/[\w-]+/,literal=replace(/(?:quoted|bool|number)/)("quoted",quoted)("bool",bool)("number",number)(),tagLine=replace(/^\s*(identifier)\s*(.*)\s*$/)("identifier",identifier)(),numberLine=replace(/^number$/)("number",number)(),boolLine=replace(/^bool$/i)("bool",bool)(),quotedLine=replace(/^quoted$/)("quoted",quoted)(),assignment=replace(/(identifier)\s*=\s*(literal)/)("identifier",identifier)("literal",literal)(),delimiter=/(?:\s*|^)/,prop=replace(/(?:delimiter)(?:(assignment|literal))/)("literal",literal)("delimiter",delimiter)("assignment",assignment)();var lexical={prop:prop,quoted:quoted,number:number,bool:bool,literal:literal,integer:integer,identifier:identifier,quotedLine:quotedLine,numberLine:numberLine,boolLine:boolLine,tagLine:tagLine};const REPLACEMENTS=Immutable.OrderedMap([["\\","\\\\"],["*","\\*"],["#","\\#"],["(","\\("],[")","\\)"],["[","\\["],["]","\\]"],["`","\\`"],["_","\\_"],["|","\\|"],['"','\\"'],["'","\\'"]]),escape$3=e=>escapeWith(REPLACEMENTS,e),unescape$1=e=>unescapeWith(REPLACEMENTS.reverse(),e);function parseLiteral(e){return e.match(lexical.numberLine)?Number(e):e.match(lexical.boolLine)?"true"===e.toLowerCase():e.match(lexical.quotedLine)?unescape$1(e.slice(1,-1)):e}function parseData(e){let t,r=0;const i={};let a=e;do{(t=a.match(lexical.prop))&&(t[2]?i[t[2]]=parseLiteral(t[3]):(i[r]=parseLiteral(t[1]),r+=1),a=a.slice(t[0].length))}while(t);return Immutable.Map(i)}function parseTag(e){const t=e.match(lexical.tagLine);return t?{tag:t[1],data:parseData(t[2])}:null}function stringifyLiteral(e){return is.bool(e)?e?"true":"false":is.string(e)?`"${escape$3(e)}"`:String(e)}function stringifyData(e){return e.entrySeq().map(([e,t])=>{const r=Number(e)>=0,i=stringifyLiteral(t);return r?i:`${e}=${i}`}).join(" ")}function stringifyTag({tag:e,data:t}){return`{% ${e}${t&&t.size>0?` ${stringifyData(t)}`:""} %}`}var liquid={parseTag:parseTag,stringifyTag:stringifyTag};function isCustomType(e){return 0===e.indexOf("x-")}function getTagFromCustomType(e){return e.slice(2)}function getCustomTypeFromTag(e){return`x-${e}`}function isClosingTag(e){return 0===e.indexOf("end")}function isClosingTagFor(e,t){return 0===e.indexOf(`end${t}`)}function wrapInDefaultBlock(e){return slate.Block.create({type:BLOCKS.DEFAULT,nodes:e})}const serialize$y=SerializerFactory().matchType(isCustomType).then(e=>{const t=e.peek(),{type:r,data:i}=t,a=liquid.stringifyTag({tag:getTagFromCustomType(r),data:i}),s="block"==t.object?"\n":"",n="block"==t.object?"\n\n":"";if(t.isVoid||t.nodes.isEmpty())return warning(t.isVoid,"Encountered a non-void custom block with no children"),e.shift().write(`${a}${n}`);const l="block"!==t.nodes.first().object;warning(!l,"Encountered a custom block containing inlines");const o=l?Immutable.List([wrapInDefaultBlock(t.nodes)]):t.nodes,c=trimTrailingLines(e.serialize(o)),u=(e.getProp("unendingTags")||Immutable.List()).includes(getTagFromCustomType(t.type))?"":liquid.stringifyTag({tag:`end${getTagFromCustomType(t.type)}`});return e.shift().write(`${a}${s}${c}${s}${u}${n}`)}),deserialize$e=DeserializerFactory().matchRegExp(block.customBlock,(e,t)=>{let r=e;if(!1===r.getProp("template"))return;const i=t[1].trim();if(!i)return r;const a=liquid.parseTag(i);if(!a)return r;const{tag:s,data:n}=a,l=slate.Block.create({type:getCustomTypeFromTag(s),data:n,isVoid:!0,nodes:Immutable.List()});if(isClosingTag(s))return r.push(l);const o=(r=r.push(l)).getProp("unendingTags")||Immutable.List();return r.lex({stopAt(e){const t=e.nodes.skip(r.nodes.size),i=t.takeUntil(e=>o.includes(s)?isCustomType(e.type)&&(isClosingTag(getTagFromCustomType(e.type))||o.includes(getTagFromCustomType(e.type))):isCustomType(e.type)&&isClosingTagFor(getTagFromCustomType(e.type),s));if(i.size==t.size)return;const a=r.nodes.butLast(),n=t.skip(i.size);return e.merge({nodes:a.push(l.merge({isVoid:!1,nodes:0==i.size?Immutable.List([r.genText()]):i})).concat(n).filterNot(e=>isCustomType(e.type)&&isClosingTag(getTagFromCustomType(e.type))&&isClosingTagFor(getTagFromCustomType(e.type),s))})}})});var custom={serialize:serialize$y,deserialize:deserialize$e},block$1=[definition,html$2,table$2,hr$1,list$1,footnote$1,blockquote$1,codeBlock,heading$2,math,comment,custom,paragraph$1,unstyled$1];const serialize$z=SerializerFactory().matchObject("text").then(e=>{const t=e.peek();return e.shift().write(t.text)}),deserializeEscaped=DeserializerFactory().matchRegExp(inline.escape,(e,t)=>e.pushText(t[1])),deserializeText=DeserializerFactory().matchRegExp(inline.text,(e,t)=>{const r=unescape(t[0]);return e.pushText(r)}),deserialize$f=DeserializerFactory().use([deserializeEscaped,deserializeText]);var text$1={serialize:serialize$z,deserialize:deserialize$f};const serialize$A=SerializerFactory().matchType(INLINES.FOOTNOTE_REF).then(e=>{const t=`[^${e.peek().data.get("id")}]`;return e.shift().write(t)}),deserialize$g=DeserializerFactory().matchRegExp(inline.reffn,(e,t)=>{const r=t[1],i=slate.Inline.create({type:INLINES.FOOTNOTE_REF,isVoid:!0,data:{id:r}});return e.push(i)});var footnote$2={serialize:serialize$A,deserialize:deserialize$g};function resolveImageRef(e,t){const r=resolveRef(e,t);return r?r.set("src",r.get("href")).remove("href"):null}function isImage(e){return"!"===e.charAt(0)}const serialize$B=SerializerFactory().matchType(INLINES.IMAGE).then(e=>{const t=e.peek(),{data:r}=t,i=escapeURL(r.get("src")||""),a=escape$2(r.get("alt")||""),s=escape$2(r.get("title")||"");let n;return n=s?`![${a}](${i} "${s}")`:`![${a}](${i})`,e.shift().write(n)}),deserializeNormal$2=DeserializerFactory().matchRegExp(inline.link,(e,t)=>{if(!isImage(t[0]))return;const r=Immutable.Map({alt:t[1]?unescape(t[1]):void 0,src:unescapeURL(t[2]),title:t[3]?unescape(t[3]):void 0}).filter(Boolean),i=slate.Inline.create({type:INLINES.IMAGE,isVoid:!0,data:r});return e.push(i)}),deserializeRef=DeserializerFactory().matchRegExp([inline.reflink,inline.nolink],(e,t)=>{if(!isImage(t[0]))return;const r=resolveImageRef(e,t[2]||t[1]);if(!r)return;const i=slate.Inline.create({type:INLINES.IMAGE,isVoid:!0,data:r});return e.push(i)}),deserialize$h=DeserializerFactory().use([deserializeNormal$2,deserializeRef]);var image$1={serialize:serialize$B,deserialize:deserialize$h};const serialize$C=SerializerFactory().matchType(INLINES.LINK).then(e=>{const t=e.peek(),{data:r,nodes:i}=t,a=e.use("inline").serialize(i),s=escapeURL(r.get("href",""));let n=escape$2(r.get("title",""));n&&(n=n?` "${n}"`:"");const l=`[${a}](${s}${n})`;return e.shift().write(l)}),deserializeNormal$3=DeserializerFactory().matchRegExp(inline.link,(e,t)=>{const r=t[1],i=e.use("inline").setProp("link",e.depth).deserialize(r),a=Immutable.Map({href:unescapeURL(t[2]),title:t[3]?unescape(t[3]):void 0}).filter(Boolean),s=slate.Inline.create({type:INLINES.LINK,nodes:i,data:a});return e.push(s)}),deserializeUrl=DeserializerFactory().matchRegExp(inline.url,(e,t)=>{if(e.getProp("link"))return;const r=unescapeURL(t[1]),i=slate.Inline.create({type:INLINES.LINK,nodes:[slate.Text.create(r)],data:{href:r}});return e.push(i)}),deserializeAutolink=DeserializerFactory().matchRegExp(inline.autolink,(e,t)=>{if(e.getProp("link"))return;const r=t[1];let i;i="@"===t[2]?`mailto:${r}`:r;const a=slate.Inline.create({type:INLINES.LINK,nodes:[slate.Text.create(r)],data:{href:i}});return e.push(a)}),deserializeRef$1=DeserializerFactory().matchRegExp([inline.reflink,inline.nolink],(e,t)=>{if(e.getProp("link"))return;const r=t[2]||t[1],i=t[1],a=resolveRef(e,r);if(!a)return;const s=e.use("inline").setProp("link",e.depth).deserialize(i),n=slate.Inline.create({type:INLINES.LINK,nodes:s,data:a});return e.push(n)}),deserializeReffn=DeserializerFactory().matchRegExp(inline.reffn,(e,t)=>{if(e.getProp("link"))return;const r=t[1],i=resolveRef(e,r);if(!i)return;const a=slate.Inline.create({type:INLINES.LINK,nodes:[slate.Text.createFromString(r)],data:i});return e.push(a)}),deserialize$i=DeserializerFactory().use([deserializeNormal$3,deserializeUrl,deserializeAutolink,deserializeReffn,deserializeRef$1]);var link$1={serialize:serialize$C,deserialize:deserialize$i};const HTML_BLOCKS=["address","article","aside","base","basefont","blockquote","body","caption","center","col","colgroup","dd","details","dialog","dir","div","dl","dt","fieldset","figcaption","figure","footer","form","frame","frameset","h1","h2","h3","h4","h5","h6","head","header","hr","html","iframe","legend","li","link","main","menu","menuitem","meta","nav","noframes","ol","optgroup","option","p","param","pre","section","source","summary","table","tbody","td","tfoot","th","thead","title","tr","track","ul"];function isHTMLBlock(e){return HTML_BLOCKS.indexOf(e.toLowerCase())>=0}function createRawHTML(e){const{openingTag:t="",closingTag:r="",innerHtml:i=""}=e;return slate.Inline.create({type:INLINES.HTML,isVoid:!0,data:{openingTag:t,closingTag:r,innerHtml:i}})}function createHTML(e){const{openingTag:t="",closingTag:r="",nodes:i}=e;return slate.Inline.create({type:INLINES.HTML,data:{openingTag:t,closingTag:r},nodes:i})}function deserializeHtml(e){const t=State.create(HTMLParser).deserializeToDocument(e),r=t.nodes.first();return!r||1===t.nodes.size&&r.type===BLOCKS.PARAGRAPH&&r.nodes.every(e=>!e.isVoid)&&""===r.text?Immutable.List():r.nodes}const serialize$D=SerializerFactory().matchType(INLINES.HTML).then(e=>{const t=e.peek(),{openingTag:r="",closingTag:i="",innerHtml:a=""}=t.data.toObject();return a?e.shift().write(r).write(a).write(i):e.shift().write(r).write(e.serialize(t.nodes)).write(i)}),deserializeComment=DeserializerFactory().matchRegExp(inline.htmlComment,(e,t)=>e),deserializePair=DeserializerFactory().matchRegExp(inline.htmlTagPair,(e,t)=>{const[r,i,a="",s=""]=t,n=`<${i}${a}>`,l=r.slice(n.length+s.length),o=(()=>{if(isHTMLBlock(i))return createRawHTML({openingTag:n,closingTag:l,innerHtml:s});const t="a"===i.toLowerCase(),r=e.setProp(t?"link":"html",e.depth).deserialize(s);return createHTML({openingTag:n,closingTag:l,nodes:r})})(),c=State.create(HTMLParser).use("block").serializeNode(o);return e.setProp("lastAnchorId",findHtmlAnchor(c)).push(deserializeHtml(c))});function findHtmlAnchor(e){let t=null;const r=new htmlparser2.Parser({onopentag(e,r){"a"===e.toLowerCase()&&r.id&&(t=r.id)}},{decodeEntities:!0});return r.write(e),r.end(),t}const deserializeClosing=DeserializerFactory().matchRegExp(inline.htmlSelfClosingTag,(e,t)=>{const[r]=t;return e.push(deserializeHtml(r))});var html$3={serialize:serialize$D,deserialize:DeserializerFactory().use([deserializeComment,deserializePair,deserializeClosing])};function normalizeTeX(e){return rtrim(ltrim(e,"\n"),"\n")}const serialize$E=SerializerFactory().matchType(INLINES.MATH).then(e=>{const t=e.peek(),{data:r}=t;let i=r.get("formula");const a=`$$${i=normalizeTeX(i)}$$`;return e.shift().write(a)}),deserialize$j=DeserializerFactory().matchRegExp(inline.math,(e,t)=>{const r=t[1].trim();if(!1===e.getProp("math")||!r)return;const i=slate.Inline.create({type:INLINES.MATH,isVoid:!0,data:{formula:r}});return e.push(i)});var math$1={serialize:serialize$E,deserialize:deserialize$j};const serialize$F=SerializerFactory().matchType(INLINES.VARIABLE).then(e=>{const t=e.peek(),{data:r}=t,i=r.get("key");return e.shift().write(`{{ ${i} }}`)}),deserialize$k=DeserializerFactory().matchRegExp(inline.variable,(e,t)=>{if(!1===e.getProp("template"))return;const r=slate.Inline.create({type:INLINES.VARIABLE,isVoid:!0,data:{key:t[1]}});return e.push(r)});var variable={serialize:serialize$F,deserialize:deserialize$k};const serialize$G=SerializerFactory().transformText((e,t)=>{const{text:r,marks:i}=t,a=i.some(e=>e.type===MARKS.CODE);return t.merge({text:a?r:escape$2(r,!1)})});var escape$4={serialize:serialize$G};const serialize$H=SerializerFactory().transformMarkedLeaf(MARKS.CODE,(e,t,r)=>{let i="`";for(;t.indexOf(i)>=0;)i+="`";return wrapInline(t,i)}),deserialize$l=DeserializerFactory().matchRegExp(inline.code,(e,t)=>{const r=t[2],i=slate.Mark.create({type:MARKS.CODE}),a=slate.Text.create({text:r,marks:[i,...e.marks]});return e.push(a)});var code$2={serialize:serialize$H,deserialize:deserialize$l};const serialize$I=SerializerFactory().transformMarkedLeaf(MARKS.BOLD,(e,t,r)=>wrapInline(t,"**")),deserialize$m=DeserializerFactory().matchRegExp(inline.strong,(e,t)=>{const r=t[2]||t[1],i=slate.Mark.create({type:MARKS.BOLD}),a=e.pushMark(i).deserialize(r);return e.push(a)});var bold$1={serialize:serialize$I,deserialize:deserialize$m};const serialize$J=SerializerFactory().transformMarkedLeaf(MARKS.ITALIC,(e,t)=>wrapInline(t,"_")),deserialize$n=DeserializerFactory().matchRegExp(inline.em,(e,t)=>{const r=t[2]||t[1],i=slate.Mark.create({type:MARKS.ITALIC}),a=e.pushMark(i).deserialize(r);return e.push(a)});var italic$1={serialize:serialize$J,deserialize:deserialize$n};const serialize$K=SerializerFactory().transformText((e,t)=>{const{text:r}=t,i=e.getProp("hardlineBreak")?"  \n":" ";return t.merge({text:r.replace(/\n/g,i)})}),deserialize$o=DeserializerFactory().matchRegExp(inline.br,(e,t)=>e.pushText("\n"));var hardlineBreak={serialize:serialize$K,deserialize:deserialize$o};const serialize$L=SerializerFactory().transformMarkedLeaf(MARKS.STRIKETHROUGH,(e,t)=>wrapInline(t,"~~")),deserialize$p=DeserializerFactory().matchRegExp(inline.del,(e,t)=>{const r=t[1],i=slate.Mark.create({type:MARKS.STRIKETHROUGH}),a=e.pushMark(i).deserialize(r);return e.push(a)});var strikethrough$1={serialize:serialize$L,deserialize:deserialize$p},inline$1=[footnote$2,image$1,link$1,math$1,html$3,variable,hardlineBreak,escape$4,code$2,bold$1,italic$1,strikethrough$1,text$1];const serialize$M=SerializerFactory().matchObject("document").then(e=>{const t=e.peek(),{data:r,nodes:i}=t,a=e.use("block").serialize(i);if(0===r.size)return e.shift().write(a);const s=`---\n${jsYaml.safeDump(r.toJS(),{skipInvalid:!0})}---\n\n`;return e.shift().write(s+a)}),deserialize$q=DeserializerFactory().then(e=>{const{text:t}=e,r=fm(t),i=e.use("block").deserialize(r.body),a=Immutable__default.fromJS(r.attributes),s=slate.Document.create({data:a,nodes:i});return e.skip(t.length).push(s)});var document$1={serialize:serialize$M,deserialize:deserialize$q};const MarkdownParser={document:[document$1],inline:inline$1,block:block$1};Object.defineProperty(exports,"Block",{enumerable:!0,get:function(){return slate.Block}}),Object.defineProperty(exports,"Document",{enumerable:!0,get:function(){return slate.Document}}),Object.defineProperty(exports,"Inline",{enumerable:!0,get:function(){return slate.Inline}}),Object.defineProperty(exports,"Leaf",{enumerable:!0,get:function(){return slate.Leaf}}),Object.defineProperty(exports,"Mark",{enumerable:!0,get:function(){return slate.Mark}}),Object.defineProperty(exports,"Text",{enumerable:!0,get:function(){return slate.Text}}),exports.BLOCKS=BLOCKS,exports.CONTAINERS=CONTAINERS,exports.Deserializer=DeserializerFactory,exports.HTMLParser=HTMLParser,exports.INLINES=INLINES,exports.LEAFS=LEAFS,exports.MARKS=MARKS,exports.MarkdownParser=MarkdownParser,exports.Serializer=SerializerFactory,exports.State=State,exports.TABLE_ALIGN=TABLE_ALIGN,exports.VOID=VOID;
